//
//  ViewController.swift
//  image
//
//  Created by kunii on 2017/07/13.
//  Copyright © 2017年 aiois. All rights reserved.
//

import UIKit

class ViewController: UIViewController {
    
    var imageView:UIImageView!      //  人物用
    var message:UILabel!            //  セリフ・説明用

    //  セリフ・説明
    let script = [
        "雨の日はだるい…\n今日は学校休んじゃおっかな〜",
        "誰だ"
    ]
    var scriptIndex = 0             //  現在の場面の段階
    
    override func viewDidLoad() {
        super.viewDidLoad()

        //  背景
        let backgroundImageView = UIImageView(frame:self.view.bounds)
        backgroundImageView.autoresizingMask = [UIViewAutoresizing.flexibleWidth, UIViewAutoresizing.flexibleHeight]
        backgroundImageView.contentMode = UIViewContentMode.scaleAspectFill
        backgroundImageView.image = UIImage(named: "fog-1")
        self.view.addSubview(backgroundImageView)
        
        //  セリフ付き前景
        let baseView = UIView(frame: self.view.bounds.insetBy(dx: 10, dy: 10))
        baseView.autoresizingMask = [UIViewAutoresizing.flexibleTopMargin, UIViewAutoresizing.flexibleWidth]
        //  タップに反応するようにする
        baseView.addGestureRecognizer(UITapGestureRecognizer(target: self, action: #selector(tap)))
        self.view.addSubview(baseView)

        //  人物部分
        var frame = baseView.bounds
        frame.size.width *= 0.5
        frame.size.height *= 0.6
        frame.origin.y += baseView.bounds.size.height - frame.size.height
        let imageView = UIImageView(frame:frame.insetBy(dx: 0, dy: 20))
        imageView.contentMode = UIViewContentMode.scaleAspectFit
        imageView.image = UIImage(named: "girl")
        imageView.alpha = 0
        baseView.addSubview(imageView)

        //  セリフ部分（すりガラス）
        frame = baseView.bounds
        frame.size.height *= 0.3
        frame.origin.y += baseView.bounds.size.height - frame.size.height
        let back = UIVisualEffectView(frame:frame.insetBy(dx: 20, dy: 20))
        back.layer.cornerRadius = 16
        back.layer.masksToBounds = true
        back.effect = UIBlurEffect(style: UIBlurEffectStyle.light)
        back.autoresizingMask = [UIViewAutoresizing.flexibleTopMargin, UIViewAutoresizing.flexibleWidth]
        baseView.addSubview(back)

        //  セリフ部分（文字）
        let message = UILabel(frame:frame.insetBy(dx: 30, dy: 30))
        message.font = UIFont.preferredFont(forTextStyle:UIFontTextStyle.title1)
        message.numberOfLines = 5
        message.autoresizingMask = [UIViewAutoresizing.flexibleTopMargin, UIViewAutoresizing.flexibleWidth]
        baseView.addSubview(message)

        //  「次へ」インジケータ
        let nextImageView = UIImageView(image:UIImage(named:"next"))
        nextImageView.center = CGPoint(x:back.frame.maxX - nextImageView.frame.size.width, y:back.frame.midY)
        nextImageView.autoresizingMask = [UIViewAutoresizing.flexibleTopMargin, UIViewAutoresizing.flexibleLeftMargin]
        baseView.addSubview(nextImageView)
        
        //  プロパティとして登録
        self.imageView = imageView
        self.message = message

        //  スタート
        self.message.text = script[scriptIndex]
        scriptIndex += 1
    }

    //  場面の段階を1つ進め、それに合わせ、セリフや状況を更新する。
    func tap() {
        if scriptIndex < script.count {
            message.text = script[scriptIndex]
            scriptIndex += 1
            if scriptIndex == script.count {
                UIView.animate(withDuration: 2, animations: { 
                    self.imageView.alpha = 1
                })
            }
        }
    }
    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }

}

